package
{
	/**
	 * Code from:
	 * http://thesaj.wordpress.com/2008/02/12/the-nightmare-that-is-_blank-part-ii-help/
	 * 
	 * USE THIS CLASS TO NAVIGATE TO A BLANK WINDOW LINK
	 * 
	 * 1.
	 * If you try the usual as3 command:
	 * navigateToURL(urlRequest, "_blank");
	 * most browsers' popupblocker don't allow this
	 * 
	 * 2.
	 * If you use wmode = transparent
	 * some browsers don't allow externInterface.call("window.open");
	 * 
	 * USAGE:
	 * NavigateToURL.getInstance().openWindow(url, window, features);
	 */
	 
	 
	import flash.external.ExternalInterface;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	public class NavigateToURL
	{
		/**
		* Singleton instantiator method.
		* 
		* @return The singleton instance
		*/
		private static var singleton:NavigateToURL;
		
		public static function getInstance() : NavigateToURL 
		{
			if ( singleton == null )	{
				singleton = new NavigateToURL();
			}
			return singleton;
		}
      
		/**
		 * Constructor should be private but current AS3.0 does not allow it yet (?)...
		 */
		function NavigateToURL() {
			if ( singleton != null )	{
				throw new Error( "Only one NavigateToURL instance should be instantiated" );	
			}
		}
		
		private function getBrowserName():String
		{
			var browser:String;
			
			//Uses external interface to reach out to browser and grab browser useragent info.
			var browserAgent:String = ExternalInterface.call("function getBrowser(){return navigator.userAgent;}");
			
			//Debug.text += "Browser Info: [" + browserAgent + "]";
			
			//Determines brand of browser using a find index. If not found indexOf returns (-1).
			if(browserAgent != null && browserAgent.indexOf("Firefox") >= 0) {
			    browser = "Firefox";
			} 
			else if(browserAgent != null && browserAgent.indexOf("Safari") >= 0){
			    browser = "Safari";
			}             
			else if(browserAgent != null && browserAgent.indexOf("MSIE") >= 0){
			    browser = "IE";
			}         
			else if(browserAgent != null && browserAgent.indexOf("Opera") >= 0){
			    browser = "Opera";
			}
			else {
			    browser = "Undefined";
			}
			return (browser);
		}
		
		//Function to pop-open ("_blank") new window: 
		public function openWindow(url:String,window:String="_blank",features:String=""):void
		{
			//Sets function name into a variable to be executed by ExternalInterface. 
			//Otherwise Flex will try to find a local function or value by that name.  
			  
			var WINDOW_OPEN_FUNCTION:String = "window.open";
			var myURL:URLRequest = new URLRequest(url);            
			var browserName:String = getBrowserName();
			
			  
			  
			//If browser is Firefox, use ExternalInterface to call out to browser 
			//and launch window via browser's window.open method.
			if(getBrowserName() == "Firefox"){
			       ExternalInterface.call(WINDOW_OPEN_FUNCTION, url, window, features);
			}
			//If IE, 
			else if(browserName == "IE"){
			    ExternalInterface.call("function setWMWindow() {window.open('" + url + "');}");
			}
			//If Safari 
			else if(browserName == "Safari"){              
			    navigateToURL(myURL, window);
			}
			//If Opera 
			else if(browserName == "Opera"){    
			    navigateToURL(myURL, window); 
			}
			//Otherwise, use Flex's native 'navigateToURL()' function to pop-window. 
			//This is necessary because Safari 3 no longer works with the above ExternalInterface work-a-round.
			else{
			    navigateToURL(myURL, window);
			}
			
			/*Alternate methodology...
			   var popSuccess:Boolean = ExternalInterface.call(WINDOW_OPEN_FUNCTION, url, window, features); 
			if(popSuccess == false){
			    navigateToURL(myURL, window);
			}*/
		 
		}
	}
}
 		