﻿/**
 * Paperskated3d - simple skateboard simulator in Papervision3d
 * 
 * @author Bartek Drozdz 
 * @version 1.0
 * 
 * Released under Creative Commons Attribution-Non-Commercial-Share Alike 3.0 License.
 */
package com.paperskate3d {
	
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import org.papervision3d.core.proto.CameraObject3D;

	public class Operator {
		private var camera:CameraObject3D;
		
		private var rotating:Boolean;
		private var cameraAngle:Number = 1;
		private var rotatingSpeed:Number = 0.02;
		
		private var moving:Boolean;
		private var movingSpeed:Number;
		private var cameraY:Number = 600;
		private var cameraRadius:Number;
		private var cameraRadiusBase:Number = 1300; // 1100;
		
		public function Operator(cam:CameraObject3D) {
			camera = cam;
			
			positionCamera();
			
			rotating = false;
			moving = false;
		}
		
		public function tick():void {
			if (rotating) {
				cameraAngle += rotatingSpeed;
				rotatingSpeed *= 1.05;
			}
			
			if (moving) {
				cameraY += movingSpeed;
				movingSpeed *= 1.1;
			}
			
			if (moving || rotating) positionCamera();
		}
		
		private function positionCamera():void {
			cameraY = Math.max(-50, cameraY);
			cameraY = Math.min(1800, cameraY);
			
			cameraRadius = cameraRadiusBase + cameraY / 2;
			
			camera.z = Math.cos(cameraAngle) * cameraRadius;
			camera.x = Math.sin(cameraAngle) * cameraRadius;
			camera.y = cameraY;
		}
		
		public function keyDown(ke:KeyboardEvent):void {
			switch (ke.keyCode) {
				case Keyboard.LEFT:
					if (rotating) return;
					rotatingSpeed = .02;
					rotating = true;
					break;
				case Keyboard.RIGHT:
					if (rotating) return;
					rotatingSpeed = -.02
					rotating = true;
					break;
				case Keyboard.UP:
					if (moving) return;
					movingSpeed = 10;
					moving = true;
					break;
				case Keyboard.DOWN:
					if (moving) return;
					movingSpeed = -10;
					moving = true;
					break;
			}
		}
		
		public function keyUp(ke:KeyboardEvent):void {
			switch (ke.keyCode) {
				case Keyboard.LEFT:
					rotating = false;
					break;
				case Keyboard.RIGHT:
					rotating = false;
					break;
				case Keyboard.UP:
					moving = false;
					break;
				case Keyboard.DOWN:
					moving = false;
					break;
			}
		}
	}
}













