﻿/**
 * Paperskated3d - simple skateboard simulator in Papervision3d
 * 
 * @author Bartek Drozdz 
 * @version 1.0
 * 
 * Released under Creative Commons Attribution-Non-Commercial-Share Alike 3.0 License.
 */
package com.paperskate3d.gui {
	
	import com.paperskate3d.util.Button;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import com.paperskate3d.gui.PSUIEvent;
	import flash.net.URLRequest;
	import NavigateToURL;

	public class HelpAbout extends Sprite {
		
		[Embed(source = '../../../../assets/ui/footer/help.png')]
		private var HelpText:Class;
		private var helpBtn:Button;
		
		[Embed(source = '../../../../assets/ui/footer/div.png')]
		private var Divider:Class;
		private var div1:Bitmap;
		private var div2:Bitmap;
		
		[Embed(source='../../../../assets/ui/footer/about.png')]
		private var AboutText:Class;
		private var aboutBtn:Button;
		
		[Embed(source='../../../../assets/ui/cc.png')]
		private var LicenseImage:Class;
		private var licenseBtn:Button;
		private var licenceUrl:URLRequest = new URLRequest("sources.php");
		
		public function HelpAbout() {

			helpBtn = new Button(new HelpText());
			addChild(helpBtn);
			
			div1 = new Divider();
			div1.x = 37;
			div1.y = -1;
			addChild(div1);
			
			aboutBtn = new Button(new AboutText());
			aboutBtn.x = 48;
			addChild(aboutBtn);
			
			div2 = new Divider();
			div2.x = 98;
			div2.y = -1;
			addChild(div2);
			
			licenseBtn = new Button(new LicenseImage());
			licenseBtn.x = 108;
			licenseBtn.y = -1;
			licenseBtn.blockHovers = true;
			addChild(licenseBtn);
			
			helpBtn.addEventListener(MouseEvent.CLICK, openHelp);
			aboutBtn.addEventListener(MouseEvent.CLICK, openBlog);
			licenseBtn.addEventListener(MouseEvent.CLICK, openLicense);
		}
		
		private function openBlog(me:MouseEvent):void {
			NavigateToURL.getInstance().openWindow("http://www.everydayflash.com/blog");
		}
		
		private function openLicense(me:MouseEvent):void {
			NavigateToURL.getInstance().openWindow("http://creativecommons.org/licenses/by-nc-sa/3.0/");
		}
		
		private function openHelp(me:MouseEvent):void {
			dispatchEvent(new PSUIEvent(PSUIEvent.OPEN_INSTRUCTION));
		}
	}
}









