﻿/**
 * Paperskated3d - simple skateboard simulator in Papervision3d
 * 
 * @author Bartek Drozdz 
 * @version 1.0
 * 
 * Released under Creative Commons Attribution-Non-Commercial-Share Alike 3.0 License.
 */
package com.paperskate3d.gui {
	
	import com.paperskate3d.util.Button;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import com.paperskate3d.util.SkateTransition;
	import com.carlcalderon.arthropod.Debug;
	
	public class Instruction extends Sprite {
		
		[Embed(source='../../../../assets/ui/instruction.png')]
		private var InsGraphic:Class;
		private var background:Bitmap;
		
		[Embed(source = '../../../../assets/ui/instructionClose.png')]
		private var CloseGraphic:Class;
		private var closeBtn:Button;
		
		public function Instruction() {
			background = new InsGraphic() as Bitmap;
			background.x = -(Math.round(background.bitmapData.width / 2));
			background.y = -(Math.round(background.bitmapData.height / 2));
			addChild(background);
			
			closeBtn = new Button(new CloseGraphic());
			addChild(closeBtn);
			closeBtn.x = 275;
			closeBtn.y = -238;
			closeBtn.addEventListener(MouseEvent.CLICK, clear);
			
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		public function init(e:Event):void {
			SkateTransition.makeIn(this, onInitReady, true);
		}
		
		public function onInitReady():void {
			// ok
		}
		
		public function clear(me:MouseEvent):void {
			SkateTransition.makeOut(this, onCleared, true);
		}
		
		public function onCleared():void {
			dispatchEvent(new PSUIEvent(PSUIEvent.INSTRUCTION_CLEARED));
		}
	}
	
}