﻿/**
 * Paperskated3d - simple skateboard simulator in Papervision3d
 * 
 * @author Bartek Drozdz 
 * @version 1.0
 * 
 * Released under Creative Commons Attribution-Non-Commercial-Share Alike 3.0 License.
 */
package com.paperskate3d.tricks {
	
	import com.paperskate3d.skate.SkateBoard;
	import flash.display.DisplayObject;
	import flash.events.Event;
	import com.carlcalderon.arthropod.Debug;

	public class BasicTrick {
		public var TRICK_TIME:Number = 1.4; // .8; 
		
		public var skateboard:SkateBoard;
		public var speed:Number;
		public var playbackSpeed:Number;
		
		public static var NOT_DEFINED:int = 0;
		protected var olliePhase:int;
		protected var fromWheelie:Boolean;
		
		protected var manager:TrickManager;
		
		public function init(skateboard:SkateBoard, manager:TrickManager, olliePhase:int = 0):void {
			this.olliePhase = olliePhase;
			this.skateboard = skateboard;
			this.manager = manager;
			this.fromWheelie = manager.hasWheelie();
		}
		
		public function get name():String { return "basic" };
		
		public function start(speed:Number, playbackSpeed:Number):void {
			if (olliePhase == Ollie.DROP || olliePhase == Ollie.BOUNCE) return;
			this.speed = speed;
			this.playbackSpeed = playbackSpeed;
			prepareTrick();
		}
		
		protected function prepareTrick():void {
			
		}
		
		private function _tick(e:Event):void {
			tick();
		}
		
		protected function tick():void {
			
		}
		
		public function end():void {
			finalizeTrick();
			manager.onTrickFinished(this);
		}
		
		protected function finalizeTrick():void {
			
		}
	}
}