﻿/**
 * Paperskated3d - simple skateboard simulator in Papervision3d
 * 
 * @author Bartek Drozdz 
 * @version 1.0
 * 
 * Released under Creative Commons Attribution-Non-Commercial-Share Alike 3.0 License.
 */
package com.paperskate3d.util {
	
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	
	public class Button extends Sprite {
		
		private var image:Bitmap;
		public var blockHovers:Boolean = false;
		
		public function Button(image:Bitmap) {
			this.image = image;
			addChild(image);
			
			buttonMode = true;
			addEventListener(MouseEvent.ROLL_OVER, onOver);
			addEventListener(MouseEvent.ROLL_OUT, onOut);
			addEventListener(MouseEvent.MOUSE_DOWN, onDown);
			addEventListener(MouseEvent.MOUSE_UP, onOut);
		}
		
		private function onOver(me:MouseEvent):void {
			if(buttonMode && !blockHovers) image.transform.colorTransform = new ColorTransform(1, 1, 1, 1, 255, 255, 255);
		}
		
		private function onOut(me:MouseEvent):void {
			image.transform.colorTransform = new ColorTransform();
		}
		
		private function onDown(me:MouseEvent):void {
			if(buttonMode) image.transform.colorTransform = new ColorTransform(.6, .6, .6);
		}
	}
}