﻿/**
 * Paperskated3d - simple skateboard simulator in Papervision3d
 * 
 * @author Bartek Drozdz 
 * @version 1.0
 * 
 * Released under Creative Commons Attribution-Non-Commercial-Share Alike 3.0 License.
 */
package com.paperskate3d.util {
	
	import flash.display.DisplayObject;
	import caurina.transitions.Tweener;

	public class SkateTransition {
		
		public static function makeIn(target:DisplayObject, callback:Function, useAlpha:Boolean=false):void {
			var a:Number = (useAlpha) ? 0 : 1;
			
			Tweener.addTween(target, { 
				_color_redMultiplier:0, 
				_color_greenMultiplier:0, 
				_color_blueMultiplier:0,
				_color_alphaMultiplier:a,
				time:0, transition:"easeOutSine" } );
			
			Tweener.addTween(target, { 
				_color_redMultiplier:1, 
				_color_greenMultiplier:1, 
				_color_blueMultiplier:1,
				_color_alphaMultiplier:1,
				delay:.5, time:.5, 
				transition:"easeOutSine", 
				onComplete:callback } );
		}
		
		public static function makeOut(target:DisplayObject, callback:Function, useAlpha:Boolean=false):void {
			var a:Number = (useAlpha) ? 0 : 1;
			
			Tweener.addTween(target, { 
				_color_redMultiplier:0, 
				_color_greenMultiplier:0, 
				_color_blueMultiplier:0,
				_color_alphaMultiplier:a,
				time:.5, 
				transition:"easeOutSine", 
				onComplete:callback } );
		}
		
	}
	
}